#ifndef ZASM_LEXER_H
#define ZASM_LEXER_H 1

#include <zasm/stream.h>
#include <zasm/tokens.h>
#include <stdio.h>

// remark: a lexer cleans up itself after end of file is reached

#define LEXER_T(O) ((struct lexer_t *)(O))
struct lexer_t
{
  struct position_t position;
  FILE *file;

  struct yy_buffer_state *buffer;
  int start_condition;
};

#define STRING_LEXER_T(O) ((struct string_lexer_t *)(O))
struct string_lexer_t
{
  struct position_t position;

  struct yy_buffer_state *buffer;
  int start_condition;
};

struct lexer_t *lexer_new(char *file);
void lexer_fill(struct lexer_t *lexer, char *file);
void lexer_execute(struct feeder_t *in, struct stream_t *out, struct lexer_t *lexer);
void lexer_delete(struct lexer_t *lexer);
void lexer_free(struct lexer_t *lexer);

struct string_lexer_t *string_lexer_new(char *input);
void string_lexer_fill(struct string_lexer_t *lexer, char *input);
void string_lexer_execute(struct feeder_t *in, struct stream_t *out, struct string_lexer_t *lexer);
void string_lexer_delete(struct string_lexer_t *lexer);
void string_lexer_free(struct string_lexer_t *lexer);

#endif
