#ifndef ZASM_NAMESPACE_H
#define ZASM_NAMESPACE_H 1

#include <zasm/hash_table.h>

#define NAMESPACE_T(O) ((struct namespace_t *)(O))
struct namespace_t
{
  // public
  struct ns_level_t *local;
  struct ns_level_t *global;
};

#define NS_LEVEL_T(O) ((struct ns_level_t *)(O))
struct ns_level_t
{
  // public
  struct hash_table_t hash_table;
  struct ns_level_t *up;
  struct namespace_t *parent;
};

struct namespace_t *namespace_new();
void namespace_fill(struct namespace_t *ns);
void namespace_add_level(struct namespace_t *ns, struct ns_level_t *level);
struct ns_level_t *namespace_del_level(struct namespace_t *ns);
struct hash_entry_t **namespace_lookup(struct namespace_t *ns, char *name, struct ns_level_t **level);
int namespace_is_empty(struct namespace_t *ns);
void namespace_delete(struct namespace_t *ns);
void namespace_free(struct namespace_t *ns);

struct ns_level_t *ns_level_new(struct namespace_t *parent);
void ns_level_fill(struct ns_level_t *level, struct namespace_t *parent);
void ns_level_delete(struct ns_level_t *level);
void ns_level_free(struct ns_level_t *level);

#endif
