#define ZASM_STRING_C 1

#include <zasm/string.h>
#include <zasm/memory.h>
#include <string.h>
#include <ctype.h>

int (*string_case)(int c) = tolower;

int string_case_sensitive(int c)
{
  return c;
}

int string_compare_case(char *s1, char *s2)
{
  for (;*s1 && *s2; s1++,s2++)
    if (string_case(*s1)!=string_case(*s2))
      return (*s2)-(*s1);
  return 0;
}

void string_change_case(char *string)
{
  for (;*string;string++)
    *string=string_case(*string);
}

char *string_new(char *c_string)
{
  int l = strlen(c_string);
  void *str;
  
  str = malloc(sizeof(int)+(l+1)*sizeof(char));
  str+=sizeof(int);
  string_fill((char *)str, c_string);
  return (char *)str;
}

void string_fill(char *string, char *c_string)
{
  STRING_REFCOUNT(string) = 1;
  strcpy(string, c_string);
}

char *string_copy(char *string)
{
  STRING_REFCOUNT(string)++;
  return string;
}

void string_delete(char *string)
{
  if (string)
    STRING_REFCOUNT(string)--;
}

void string_free(char *string)
{
  void *data;
  if (string)
    {
      string_delete(string);
      if (STRING_REFCOUNT(string) <= 0)
	{
	  data = string;
	  data -= sizeof(int);
	  free(data);
	}
    }
}

