#ifndef ZASM_PARSER_H
#define ZASM_PARSER_H 1

#include <zasm/list.h>
#include <zasm/feeder.h>
#include <zasm/expr.h>

struct pp_arg_t
{
  char *name;
  struct list_t *value;
};

struct token_t preprocessor_p(struct feeder_t *input, struct token_t *token);
struct expr_t *parse_expr(struct feeder_t *input, struct token_t *token, struct expr_alloc_t **alloc);

struct list_t *substitute_macro(struct list_t *body, struct list_t *arg_names, struct list_t *arg_values);
struct list_t *substitute_for_in(struct list_t *body, char *name, struct list_t *values);
struct list_t *substitute_for_from(struct list_t *body, char *name, int from, int to, int step);

#define get_block_p(input,token,ends...) parser_get_block(input,token, ## ends, TOKENS_COUNT)
#define skip_block_p(input,token,ends...) parser_skip_block(input,token, ## ends, TOKENS_COUNT)
#define process_block_p(input,token,ends...) parser_process_block(input,token, ## ends, TOKENS_COUNT)
struct token_t parser_get_block(struct feeder_t *input, struct token_t *token, ...);
struct token_t parser_skip_block(struct feeder_t *input, struct token_t *token, ...);
struct token_t parser_process_block(struct feeder_t *input, struct token_t *token, ...);

#endif
