/* tokens used by the preprocessor

#token void TOK_BACKSLASH = /\\\\/ {} & {WRITE("\\");}

#token struct expr_t *TOK_EXPR = & {WRITE("<expr>");}
#token struct list_t *TOK_LIST = & {WRITE("<list>");}
#token char *TOK_END_FILE = & {WRITE("<endFile>");}

#token void TOK_OP_IFTHEN = /\\?/ {} & {WRITE("?");}
#token void TOK_OP_ELSE = /:/ {} & {WRITE(":");}

#token void TOK_OP_LOG_OR  = /"||"/ {} & {WRITE("||");}
#token void TOK_OP_LOG_AND = /"&&"/ {} & {WRITE("&&");}
#token void TOK_OP_LOG_XOR = /"^^"/ {} & {WRITE("^^");}
#token void TOK_OP_LOG_NOT = /"!!"|"!"|"~~"/ {} & {WRITE("!");}

#token void TOK_OP_BIN_OR  = /"|"|".|"/ {} & {WRITE(".|");}
#token void TOK_OP_BIN_AND = /".&"/ {} & {WRITE(".&");}
#token void TOK_OP_BIN_XOR = /"^"|".^"/ {} & {WRITE(".^");}
#token void TOK_OP_BIN_NOT = /".!"|".~"|"~"/ {} & {WRITE(".~");}

#token void TOK_OP_SHIFT_LEFT  = /"<<"|".<"/ {} & {WRITE("<<");}
#token void TOK_OP_SHIFT_RIGHT = /">>"|".>"/ {} & {WRITE(">>");}

#token void TOK_OP_EQU = /"=="|"="/ {} & {WRITE("==");}
#token void TOK_OP_NEQ = /"!="|"\/="|"<>"/ {} & {WRITE("!=");}
#token void TOK_OP_LT  = /"<"/ {} & {WRITE("<");}
#token void TOK_OP_GT  = /">"/ {} & {WRITE(">");}
#token void TOK_OP_LE  = /"<="|"=<"/ {} & {WRITE("<=");}
#token void TOK_OP_GE  = /">="|"=>"/ {} & {WRITE(">=");}
#token void TOK_OP_CMP = /"<=>"|">=<"/ {} & {WRITE("<=>");}

#token void TOK_OP_ADD  = /"+"/ {} & {WRITE("+");}
#token void TOK_OP_SUB  = /"-"/ {} & {WRITE("-");}
#token void TOK_OP_MUL  = /"*"/ {} & {WRITE("*");}
#token void TOK_OP_DIV  = /"\/"/ {} & {WRITE("/");}
#token void TOK_OP_MOD  = /"%"/ {} & {WRITE("%%");}
#token void TOK_OP_POW  = /"**"/ {} & {WRITE("**");}

#token void TOK_DOT = /"."/ {} & {WRITE(".");}

#token void TOK_PAREN_OPEN = /\\(/ {} & {WRITE("(");}
#token void TOK_PAREN_CLOSE = /\\)/ {} & {WRITE(")");}
#token void TOK_BRACE_OPEN = /\\{/ {} & {WRITE("{");}
#token void TOK_BRACE_CLOSE = /\\}/ {} & {WRITE("}");}
#token void TOK_SQUARE_OPEN = /\\[/ {} & {WRITE("[");}
#token void TOK_SQUARE_CLOSE = /\\]/ {} & {WRITE("]");}

#token void TOK_COMMA = /,/ {} & {WRITE(", ");}
#token void TOK_PASTE = /"##"|"&"/ {} & {WRITE(" ## ");}
#token void TOK_DEFINED = /defined/ {} & {WRITE("defined");}

#token void TOK_DEFINE = /{DIR}(define|def|declare)/ {}
                       & {WRITE("#define");}
#token void TOK_MACRO = /{DIR}(macro)/ {}
                       | /macro/ {}
                       & {WRITE(".macro");}
#token void TOK_REDEF = /{DIR}(redefine|redef|redeclare)/ {} & {WRITE("#redef");}
#token void TOK_UNDEF = /{DIR}(undefine|undef|undeclare)/ {} & {WRITE("#undef");}
#token void TOK_ENDM = /{DIR}(endm|endmacro|enddefine|enddef|enddeclare)/ {} & {WRITE("#endm");}
#token void TOK_PP_BEGIN_SECTION = /{DIR}(pp_begin_section)/ {} & {WRITE("#pp_begin_section");}
#token void TOK_PP_END_SECTION = /{DIR}(pp_end_section)/ {} & {WRITE("#pp_end_section");}
#token void TOK_INCLUDE = /{DIR}(include|input)/ {BEGIN(INCLUDE);} & {WRITE("#include");}
#token void TOK_IF = /{DIR}(if)/ {} & {WRITE("#if");}
#token void TOK_THEN = /{DIR}(then)/ {} & {WRITE("#then");}
#token void TOK_IFDEF = /{DIR}(ifdef)/ {} & {WRITE("#ifdef");}
#token void TOK_IFNDEF = /{DIR}(ifndef)/ {} & {WRITE("#ifndef");}
#token void TOK_ELSE = /{DIR}(else)/ {} & {WRITE("#else");}
#token void TOK_ELSEIF = /{DIR}(elseif|elsif)/ {} & {WRITE("#elseif");}
#token void TOK_ELSEIFDEF = /{DIR}(elseifdef|elsifdef)/ {} & {WRITE("#elseifdef");}
#token void TOK_ELSEIFNDEF = /{DIR}(elseifndef|elsifndef)/ {} & {WRITE("#elseifndef");}
#token void TOK_ENDIF = /{DIR}(endif)/ {} & {WRITE("#endif");}
#token void TOK_FOR = /{DIR}(for)/ {} & {WRITE("#for");}
#token void TOK_IN = /{DIR}(in)/ {} & {WRITE("#in");}
#token void TOK_FROM = /{DIR}(from)/ {} & {WRITE("#from");}
#token void TOK_TO = /{DIR}(to)/ {} & {WRITE("#to");}
#token void TOK_STEP = /{DIR}(step)/ {} & {WRITE("#step");}
#token void TOK_DO = /{DIR}(do)/ {} & {WRITE("#do");}
#token void TOK_ENDFOR = /{DIR}(endfor)/ {} & {WRITE("#endfor");}
#token void TOK_ERROR = /{DIR}(error)/ {} & {WRITE("#error");}
#token void TOK_WARNING = /{DIR}(warning)/ {} & {WRITE("#warning");}
#token void TOK_DEBUG = /{DIR}(debug)/ {} & {WRITE("#debug");}

*/
