#ifndef ZASM_FEEDER_H
#define ZASM_FEEDER_H 1

enum
  {
    FEEDER_SRC_LIST,
    FEEDER_SRC_ACTION, 
    FEEDER_SRC_INVALID
  };

// feeder_t is in stream.h

#define FEEDER_SRC_T(O) ((struct feeder_src_t *)(O))
struct feeder_src_t
{
  // public
  int type;
  struct feeder_src_t *previous;
  union
  {
    struct stream_t *stream;
    struct list_t *list;
  } content;
};

#include <zasm/tokens.h>
#include <zasm/stream.h>
#include <zasm/list.h>

struct feeder_t *feeder_new();
void feeder_fill(struct feeder_t *feeder);
void feeder_backup(struct feeder_t *feeder);
void feeder_stop_backup(struct feeder_t *feeder);
void feeder_restore(struct feeder_t *feeder);
void feeder_flush1(struct feeder_t *feeder, struct stream_t *output);
void feeder_add_list(struct feeder_t *feeder, struct list_t *list);
void feeder_add_action(struct feeder_t *feeder, struct action_t *action);
//void feeder_add_feeder(struct feeder_t *feeder, struct feeder_t *other);
struct token_t feeder_get(struct feeder_t *feeder);
void feeder_unget(struct feeder_t *feeder, struct token_t token);
void feeder_delete(struct feeder_t *feeder);
void feeder_free(struct feeder_t *feeder);

struct feeder_src_t *feeder_src_new();
void feeder_src_fill(struct feeder_src_t *src);
struct token_t feeder_src_get(struct feeder_src_t *src);
void feeder_src_unget(struct feeder_src_t *src, struct token_t token);
void feeder_src_delete(struct feeder_src_t *src);
void feeder_src_free(struct feeder_src_t *src);

#endif
